#include <iostream>
#include "linkedListUpdated.h"
#include <ctime>
#include "myDynamicArray.h"
#include <cassert>
#include <cmath>

using namespace std;

/*
//ex 1
void intersectArrays(int [], int , int [], int , int [], int &);

void intersectArrays(int A[], int n, int B[], int m, int C[], int & k) {
	k=0;
	for (int i=0;i<n;i++)
		for (int j=0;j<m;j++)
			if (A[i]==B[j]) { C[k]=A[i]; k++;}	
}

void swap(int *a, int *b) {
	int temp;
	temp=*a;
	*a=*b;
	*b=temp;
}

int partition(int *A,int start,int end) {
	int x=A[end];
	int i = start, j= end-1;
	while (i < j) {
		int a=0,b=0;
		if (A[i]>x) a = 1;
		else i++;
		if (A[j]<x) b = 1;
		else j--;
		if (a==1 && b==1) swap(A[i],A[j]);			
	}
	//swap(A[i],A[end-1]);
	//return i;
	for (i=0;i<end;i++) if (A[i]>x) {swap(A[i],A[end]); return i;}
	return end;
}

void randQuickSort(int A[], int start, int end) {
	if(end>start){
		swap( A[start + rand()%(end-start+1)] , A[end]);
		int q = partition(A,start,end);
		randQuickSort(A,start,q-1);
		randQuickSort(A,q,end);
	}
}

int binarySearch(int  A[],int n,int x) 
{ 
       int start = 0;
       int end = n-1;
       while( start <=end) {  
                 int mid = (start+end)/2; 
                 if (A[mid] < x)
                          start = mid +1;
                 else if (A[mid] > x)
                          end = mid - 1; 
                 else if (A[mid] ==x)
                          return mid; 
	  } 
      return -1; 
} 


void fastIntersectArrays(int A[], int n, int B[], int m, int C[], int & k) {
	k=0;
	randQuickSort(B,0,m);
	for (int i=0;i<n;i++) {
		int j = binarySearch(B,m,A[i]);
		if (j != -1) { C[k]=B[j]; k++; }
	}
}




void main () {
	srand((unsigned)time(NULL));
	int A[]={1,2,3,4,5},n=5,B[]={2,4,3},m=3,C[100],k=0;
	fastIntersectArrays(A,n,B,m,C,k);
	for (int i=0;i<k;i++) cout<<C[i]<<" ";
}
*/

//ex 3

class realVector: public	myDynamicArray<double>
{
public:
   realVector() {size=0;A=NULL;}
   realVector(int dimensionValue) : myDynamicArray<double>(dimensionValue)  {}
   realVector(const realVector & other) {copy(other);}
   int dimension() const {return size;}
   realVector  operator+(const realVector & q) const {
       assert(dimension()==q.dimension());
	   realVector  r(dimension());
	   for(int i=0;i<dimension();i++) 
		   r.A[i] = A[i]+q.A[i];
	   return r;
   }
   realVector  operator-() const {
	   realVector  r(dimension());
	   for(int i=0;i<dimension();i++) 
		   r.A[i] = - A[i];
	   return r;
   }
   double  operator*(const realVector & q) const {
       assert(dimension()==q.dimension());
	   double scalarProduct=0;
	   for(int i=0;i<dimension();i++) 
		    scalarProduct= scalarProduct+A[i]*q.A[i];
	   return scalarProduct;
   }
   double norm() const {
	   return pow((*this)*(*this),0.5);
   }
   void  print() const {
	   cout<<"<";
	   for(int i=0;i<dimension();i++) {
		   cout<<A[i];
           if(i!=dimension()-1)
			   cout<<" ";
	   }
	   cout<<">"<<endl;

   }  
};







void main(){ // test program

  //  1. declare a boolean vector x of dimension 3 
  realVector x(3);
  //  2. set the entries of x so that x = < 1,-2,3 >
  x.set(0,1);
  x.set(1,-2);
  x.set(2,3);
  //  3. print x
  cout<<"3. x=";x.print();
  //  4. declare a boolean  vector y initialized to x 
  realVector y = x;
  //  5. set the first entry of y to -1.5 and its third entrie to 2
  y.set(0,-1.5);
  y.set(2,2);
  //  6. print y 
  cout<<"6. y=";y.print();
  //  7. print the norm of y using the norm member function
  cout<<"7. ||y||="<<y.norm()<<endl;
  //  8. print the scalar  product  x*y 
  cout<<"8. x*y="<<x*y<<endl;
  //  9. declare a boolean  vector z initialized to -x
  realVector z = -x;
  // 10. print z
  cout<<"10. z=";z.print();
  // 11. assign to z the vector z+y
  z = z+y;
  // 12. print z
  cout<<"12. z=";z.print();  
}

/*
//ex 4
void main() {
	linkedListType<int> L;
	L.insertLast(1);
	L.insertLast(3);
	L.insertLast(3);
	L.insertLast(3);
	L.insertLast(4);
	L.insertLast(7);
	L.insertLast(7);
	L.insertLast(9);
	L.insertLast(9);
	L.insertLast(9);
	L.insertLast(9);
	L.print();
	L.removeDuplicates();
	cout<<endl;
	L.print();
}
*/
